subroutine createhhdata(fname)

  !this subroutine creates a household data set suitable for estimation
  !what it does is somewhat similar to cardusage and shoppingocc
  !the difference is that the data has to be cut in a different way
  !and the product space has to be redefined somewhat

  use params
  implicit none


  character(28) x
  character(*) fname
  integer hhid, market, week, toint, counter, storeid, oldweek, sttype
  integer k, l, dollars, maxdollars, maxdollarstore

  integer i,n,hh,hhidold,j,s,hlen,jnew,i1,i2,st
  integer bundlenum,tcans,nsale
  doubleprecision, allocatable :: hhtemp(:,:,:)

  integer, parameter :: prmax = 10000

  doubleprecision stprice, stpriceind

  logical inlist, getout

  doubleprecision u(1),m(2)

  doubleprecision s1, s2, s3, s4, s5, s6, s7, s8
  doubleprecision fbought,vfbought,maxfbought,minfbought

  integer iptimes(54)   !interpurchase timing
  integer ptold

  doubleprecision pincr
  integer pbads, findinlist, rep, nrep

  doubleprecision pvars(2)                       !price variances
  doubleprecision pmeans(2)                      !means

  doubleprecision avdiff(2)                      !diff between sale & nonsale price
  logical, parameter :: roundp = .true.          !are we rounding the price to the nearest whole number
  logical found, allzero
  doubleprecision round2, ptemp(3*numprods)

  external DRNUN

  if(10+numprods*3 .gt. nhhvars) then
     print*,'Error in data variables: nhhvars is',nhhvars
     print*,'but data variables will end at',10+numprods*3
     stop
  endif

  ! load household data and SAS price files after R processing
  open(unit=1,file=pathname//prodname//'/Rinfo_hn.txt')
    read(1,*) n
  read(1,*) hlen
  close(unit=1,status='keep')

  allocate(hhweek(nhhvars,maxpurchases,hlen))
  allocate(hhstorevisits(2,maxpurchases,hlen))
  allocate(initweek(nhhvars,wkstart,hlen))

  open(unit=1,file=pathname//prodname//'/Rhhweek_hn.txt')

  do hh=1,hlen
     do i=1,maxpurchases
        read(1,*) hhweek(:,i,hh)
     enddo
  enddo
  close(unit=1,status='keep')

  open(unit=1,file=pathname//prodname//'/Rinitweek_hn.txt')

  do hh=1,hlen
     do i=1,wkstart
        read(1,*) initweek(:,i,hh)
     enddo
  enddo
  close(unit=1,status='keep')

  ! load store data from collapsed SAS price files
  allocate(sasprices(50,wkstart+maxpurchases,3*numprods))
  open(unit=1,file=pathname//prodname//'/Rstores_hn.txt')
  do n=1,50
     do i=1,wkstart+maxpurchases
        read(1,*) sasprices(n,i,1:(3*numprods))
        if(stmarket(n) .eq. 1) then
           s1=0.d0
           do j=1,numprods
              s1=s1+sasprices(n,i,j)
           enddo
           if(s1 .eq. 0.d0) then
              print*,'WARNING: all prices 0 in store ',n,' week ',i
           endif
        endif
     enddo
  enddo
  close(unit=1,status='keep')

  open(unit=1,file=pathname//prodname//'/ivstats.txt')
  do i=1,2
     read(1,*) impdist(i,:)
  enddo
  close(unit=1,status='keep')

  allocate(impdisthh(2,hlen,niv))

  open(unit=1,file=pathname//prodname//'/ivstatshh.txt')
  do hh=1,hlen
     read(1,*) impdisthh(1,hh,:)
  enddo
  do hh=1,hlen
     read(1,*) impdisthh(2,hh,:)
  enddo
  close(unit=1,status='keep')

  !round prices to the nearest cent

  do hh=1,hlen
     do i=1,wkstart
        do j=1,numprods
           initweek(sthhind+j,i,hh) = round2(initweek(sthhind+j,i,hh))
        enddo
     enddo
  enddo

  do hh=1,hlen
     do i=1,maxpurchases
        do j=1,numprods
           hhweek(sthhind+j,i,hh) = round2(hhweek(sthhind+j,i,hh))
        enddo
     enddo
  enddo

  do n=1,50
     do i=1,wkstart+maxpurchases
        do j=1,numprods
           sasprices(n,i,j) = round2(sasprices(n,i,j))
        enddo
     enddo
  enddo


  !look at var of visit prob

  s1 = 0.d0
  s2 = 0.d0
  s5 = 0
  s3 = 0
  s4 = 0
  s6 = 0

  do hh=1,hlen

     s1 = s1 + hhweek(nhhvars-2,1,hh)
     s2 = s2 + hhweek(nhhvars-2,1,hh)**2

     hhstorevisits(1,:,hh) = 0

     do n=1,maxpurchases

        if(hhweek(sthhind,n,hh) .gt. 0) then

           k=1
           j=0
           do while(hhstorevisits(1,k,hh) .gt. 0)
              if(hhstorevisits(1,k,hh) .eq. int(hhweek(sthhind,n,hh))) then
                 j=j+1
                 hhstorevisits(2,k,hh) = hhstorevisits(2,k,hh) + 1
              endif
              k=k+1
           enddo
           if(j .eq. 0) then
              hhstorevisits(1,k,hh) = int(hhweek(sthhind,n,hh))
              hhstorevisits(2,k,hh) = 1
           endif
        endif

        s5=s5+1
        if(hhweek(1,n,hh) .gt. 0) then
           s3=s3+1
        endif

        if(hhweek(3,n,hh) .gt. 0) then
           s4=s4+1
        endif

        if(hhweek(1,n,hh) .gt. 0 .or. hhweek(3,n,hh) .gt. 0) then
           s6=s6+1
        endif

     enddo

     if(hhstorevisits(1,1,hh) .eq. 0) then
        write(*,*) "bug",hh,hhweek(sthhind,1:maxpurchases,hh)
        write(*,*) hhweek(1,1,hh)
        stop
     endif

  enddo

  s2 = (s2*dble(hlen) - s1**2)/dble(hlen*(hlen-1))
  s1 = s1/dble(hlen)

  write(*,*) '***Final data set statistics***'
  write(*,*) 'Fraction of times a purchase of sk, cos, either are observed',s3/s5,s4/s5,s6/s5
  write(*,*) 'Mean store visit prob: ',s1
  write(*,*) 'Std dev: ',sqrt(s2)

  if(allfixed .eq. 1) hhweek(nhhvars-2,:,:) = s1


  allocate(hhprices(3*numprods,prmax))

  hhprices = 0.d0

  iptimes = 0

  do hh=1,hlen

     ptold = 1

     do i=1,maxpurchases

        if(hhweek(sthhind,i,hh) .gt. 0) then

           if(hhweek(1,i,hh) .gt. 0) then

              iptimes(i-ptold+1) = iptimes(i-ptold+1) + 1
              ptold = i

           endif

           nrep = 1

           do j=1,2*numprods
              if(hhweek(sthhind+numprods+j,i,hh) .gt. 0.d0) nrep = 2
           enddo

           do rep=1,nrep

              k=1

              if(rep .eq. 1) then
                 ptemp = hhweek((sthhind+1):(sthhind+3*numprods),i,hh)
              else
                 ptemp(1:numprods) = hhweek((sthhind+1):(sthhind+numprods),i,hh)
                 ptemp((numprods+1):(3*numprods)) = 0.d0
              endif

              do while( .not. allzero(hhprices(1:numprods,k),numprods) )

                 found = .true.

                 do j=1,numprods

                    found = found .and. (hhprices(j,k) .eq. ptemp(j))

                 enddo

                 if(usefeatures) then
                    do j=1,numprods
                       found = found .and. (hhprices(j+numprods,k) .eq. ptemp(j+numprods))
                    enddo
                 endif

                 if(usedisplay) then
                    do j=1,numprods
                       found = found .and. (hhprices(j+2*numprods,k) .eq. ptemp(j+2*numprods))
                    enddo
                 endif

                 if(found) then
                    k=-1
                    exit
                 endif
                 k=k+1

              enddo

              if(k .ne. -1) then

                 hhprices(:,k) = ptemp

              endif

           enddo

        endif

     enddo

  enddo

  !add in prior prices if we're not estimating initial conditions

  allocate(initprice(3*numprods,50,wkstart),pptrstatei(50,wkstart))

  do i=1,50
     if(stmarket(i) .eq. 1) then

        do n=1,wkstart

           initprice(:,i,n) = sasprices(i,n,:)

           nrep = 1

           do j=1,2*numprods
              if(initprice(numprods+j,i,n) .gt. 0.d0) nrep = 2
           enddo

           do rep=1,nrep

              if(rep .eq. 1) then
                 ptemp = initprice(:,i,n)
              else
                 ptemp(1:numprods) = initprice(1:numprods,i,n)
                 ptemp((numprods+1):(3*numprods)) = 0.d0
              endif

              k=1

              do while( .not. allzero(hhprices(1:numprods,k),numprods) )

                 found = .true.

                 do j=1,numprods

                    found = found .and. (hhprices(j,k) .eq. ptemp(j))

                 enddo

                 if(usefeatures) then
                    do j=1,numprods
                       found = found .and. (hhprices(j+numprods,k) .eq. ptemp(j+numprods))
                    enddo
                 endif

                 if(usedisplay) then
                    do j=1,numprods
                       found = found .and. (hhprices(j+2*numprods,k) .eq. ptemp(j+2*numprods))
                    enddo
                 endif

                 if(found) then
                    pptrstatei(i,n) = k
                    k=-1
                    exit
                 endif
                 k=k+1

              enddo

              if(k .ne. -1) then
                 if(k .gt. prmax) then
                    print*,'max limit of hhprices exceeded'
                    stop
                 endif

                 hhprices(:,k) = ptemp
                 pptrstatei(i,n) = k

              endif

           enddo

        enddo

     endif

  enddo

  open(unit=1,file=pathname//prodname//'/iptimes.txt')

  do i=1,54
     write(1,*) iptimes(i)
  enddo

  close(unit=1,status='keep')

  k=0

  open(unit=1,file=pathname//prodname//'/pricelist.dat')

  do i=1,prmax

     if(.not. allzero(hhprices(:,i),numprods)) then
        k=k+1
        write(1,*) hhprices(:,i)
     endif

  enddo

  close(unit=1,status='keep')

  write(*,*) 'Total number of observed prices:',k

  nobspr = k

  ! if you didn't go to the store at the beginning of the data we'll use the first store visited
  ! note for the soup data store visits are observed starting in week 198625, so we can actually
  ! start the imputations earlier

  do hh=1,hlen

     if(initweek(sthhind,wksample+1,hh) .eq. 0) then

        do i=wksample+1,wkstart+maxpurchases

           if(i .le. wkstart) then

              if(initweek(sthhind,i,hh) .gt. 0) then
                 j = int(initweek(sthhind,i,hh))
                 k = i
                 exit
              endif

           else

              if(hhweek(sthhind,i-wkstart,hh) .gt. 0) then
                 j = int(hhweek(sthhind,i-wkstart,hh))
                 k = i
                 exit
              endif

           endif

        enddo

        do i=wksample+1,k-1

           if(i .le. wkstart) then

              initweek((sthhind+1):(sthhind+numprods),i,hh) = sasprices(j,i,1:numprods)
              initweek((sthhind+numprods+1):(sthhind+3*numprods),i,hh) = 0.d0

           else

              hhweek((sthhind+1):(sthhind+numprods),i-wkstart,hh) = sasprices(j,i,1:numprods)
              hhweek((sthhind+numprods+1):(sthhind+3*numprods),i-wkstart,hh) = 0.d0

           endif

        enddo

     endif

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then
           if(initweek(sthhind,i,hh) .gt. 0) then
              ptemp = 0.d0
              ptemp(1:numprods) = initweek((sthhind+1):(sthhind+numprods),i,hh)
           else
              initweek((sthhind+1):(sthhind+3*numprods),i,hh) = ptemp
           endif
        else
           if(hhweek(sthhind,i-wkstart,hh) .gt. 0) then
              ptemp = 0.d0
              ptemp(1:numprods) = hhweek((sthhind+1):(sthhind+numprods),i-wkstart,hh)
           else
              hhweek((sthhind+1):(sthhind+3*numprods),i-wkstart,hh) = ptemp
           endif
        endif

     enddo


  enddo

  ! fill in hhweek(nhhvars-1,) which shows the index of the prices observed by the household

  do hh=1,hlen

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then
           ptemp = initweek((sthhind+1):(sthhind+3*numprods),i,hh)
        else
           ptemp = hhweek((sthhind+1):(sthhind+3*numprods),i-wkstart,hh)
        endif

        do k=1,nobspr

           found = .true.

           do j=1,numprods

              found = found .and. (hhprices(j,k) .eq. ptemp(j))

           enddo

           if(usefeatures) then

              do j=1,numprods

                 found = found .and. (hhprices(j+numprods,k) .eq. ptemp(j+numprods))

              enddo

           endif

           if(usedisplay) then

              do j=1,numprods

                 found = found .and. (hhprices(j+2*numprods,k) .eq. ptemp(j+2*numprods))

              enddo

           endif

           if(found) then
              if(i .le. wkstart) then
                 initweek(nhhvars-1,i,hh) = k
              else
                 hhweek(nhhvars-1,i-wkstart,hh) = k
              endif
              exit
           endif

        enddo

     enddo

  enddo

  nhhs = hlen



  write(*,*) 'Number of bad initial observations:',j

  !figure out how many value functions we will need to save - after the second loops (after the allocate) hhweek(nhhvars,) will be positive for each
  !value function we save.  This way we only interpolate the value function when we need to

  do hh=1,hlen

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then

           if(initweek(nhhvars-1,i,hh) .gt. 0) then

              if(.not. inlist(int(initweek(nhhvars-1,i,hh)),wkstart-wksample,int(initweek(nhhvars,(wksample+1):wkstart,hh))) ) then

                 k=1
                 do while(initweek(nhhvars,wksample+k,hh) .gt. 0)
                    k=k+1
                 enddo

                 initweek(nhhvars,wksample+k,hh) = initweek(nhhvars-1,i,hh)

              endif

           endif

        else

           if(hhweek(nhhvars-1,i-wkstart,hh) .gt. 0) then

              if(.not. inlist(int(hhweek(nhhvars-1,i-wkstart,hh)),maxpurchases,int(hhweek(nhhvars,:,hh))) ) then

                 k=1
                 do while(hhweek(nhhvars,k,hh) .gt. 0)
                    k=k+1
                 enddo

                 hhweek(nhhvars,k,hh) = hhweek(nhhvars-1,i-wkstart,hh)

              endif

           endif
           
        endif

     enddo

  enddo

  !compute probability distributions over prices

  allocate(primpdistf(nhhs,wkstart+maxpurchases,2),primpdistp(nhhs,wkstart+maxpurchases,2))

  primpdistf = 0

  do hh=1,hlen

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then

           if(initweek(nhhvars-1,i,hh) .gt. 0) then

              k = findinlist(int(initweek(nhhvars-1,i,hh)),wkstart+maxpurchases,primpdistf(hh,:,1))

              if(k .le. 0) then

                 k=1
                 do while(primpdistf(hh,k,1) .gt. 0)
                    k=k+1
                 enddo

                 primpdistf(hh,k,1) = initweek(nhhvars-1,i,hh)
                 primpdistf(hh,k,2) = 1

              else

                 primpdistf(hh,k,2) = primpdistf(hh,k,2) + 1

              endif

           endif

        else

           if(hhweek(nhhvars-1,i-wkstart,hh) .gt. 0) then

              k = findinlist(int(hhweek(nhhvars-1,i-wkstart,hh)),maxpurchases,primpdistf(hh,:,1))

              if(k .le. 0) then

                 k=1
                 do while(primpdistf(hh,k,1) .gt. 0)
                    k=k+1
                 enddo

                 primpdistf(hh,k,1) = hhweek(nhhvars-1,i-wkstart,hh)
                 primpdistf(hh,k,2) = 1

              else

                 primpdistf(hh,k,2) = primpdistf(hh,k,2) + 1

              endif

           endif

        endif

     enddo

     k=1

     primpdistp(hh,:,:) = 0.d0

     s1 = 0.d0

     do while (primpdistf(hh,k,1) .gt. 0)

        s1 = s1 + dble(primpdistf(hh,k,2))

        primpdistp(hh,k,1) = dble(primpdistf(hh,k,2))

        primpdistp(hh,k,2) = s1

        k = k + 1

        if(k .gt. maxpurchases) exit

     enddo

     primpdistp(hh,:,:) = primpdistp(hh,:,:)/s1

  enddo


  j=0

  allocate(pstateptr(nobspr,hlen),pptrstate(wkstart+maxpurchases,hlen))

  do hh=1,hlen

     k=0

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then

           if(initweek(nhhvars,i,hh) .gt. 0) then
              k=k+1
              pptrstate(k,hh) = int(initweek(nhhvars,i,hh))
              pstateptr(int(initweek(nhhvars,i,hh)),hh) = k
              initweek(nhhvars,i,hh) = k
           endif

        else

           if(hhweek(nhhvars,i-wkstart,hh) .gt. 0) then
              k=k+1
              pptrstate(k,hh) = int(hhweek(nhhvars,i-wkstart,hh))
              pstateptr(int(hhweek(nhhvars,i-wkstart,hh)),hh) = k
              hhweek(nhhvars,i-wkstart,hh) = k
           endif

        endif

     enddo

     j=j+k

  enddo

  do hh=1,hlen

     do i=1,maxpurchases

        if(hhweek(nhhvars,i,hh) .gt. wkstart+maxpurchases-wksample) then
           print*,'bug in hhweek(nhhvars) indexing',i,hh,int(hhweek(nhhvars,i,hh)),int(hhweek(nhhvars-1,i,hh))
        endif

     enddo

     j=j+k

  enddo


  write(*,*) 'Total number of possible saved value functions:',j

  ! similar calculations for the simulated data

  allocate(hhdatatemp(4,wkstart+maxpurchases,hh),wtind(wkstart+maxpurchases,50))

  !  create store indexes - number of stores by number of weeks

  j=0

  do st=1,50

    if(stmarket(st) .eq. 1) then

      do i=1,wkstart+maxpurchases

        j=j+1

        wtind(i,st) = j

      enddo

    endif

  enddo

  ! assume that if a household doesn't visit a store then they remember price from last store

  hhdatatemp = 0

  do hh=1,hlen

     if(initweek(sthhind,wksample+1,hh) .le. 0) then

        do i=wksample+1,wkstart+maxpurchases
           
           if(i .le. wkstart) then

              if(initweek(sthhind,i,hh) .gt. 0) then
                 j = int(initweek(sthhind,i,hh))
                 k = i
                 exit
              endif

           else

              if(hhweek(sthhind,i-wkstart,hh) .gt. 0) then
                 j = int(hhweek(sthhind,i-wkstart,hh))
                 k = i
                 exit
              endif

           endif

        enddo

        do i=1,k-1
           hhdatatemp(1,i,hh) = wtind(i,j)
           hhdatatemp(3,i,hh) = j
        enddo

     endif

     do i=wksample+1,wkstart+maxpurchases

        if(i .le. wkstart) then

           if(initweek(sthhind,i,hh) .gt. 0) then

              hhdatatemp(1,i,hh) = wtind(i,int(initweek(sthhind,i,hh)))
              hhdatatemp(3,i,hh) = int(initweek(sthhind,i,hh))

           else if(i .gt. wksample+1) then

              if(hhdatatemp(1,i-1,hh) .gt. 0) then
                 hhdatatemp(1,i,hh) = hhdatatemp(1,i-1,hh)
                 hhdatatemp(3,i,hh) = hhdatatemp(3,i-1,hh)
              endif

           endif

        else

           if(hhweek(sthhind,i-wkstart,hh) .gt. 0) then

              hhdatatemp(1,i,hh) = wtind(i,int(hhweek(sthhind,i-wkstart,hh)))
              hhdatatemp(3,i,hh) = int(hhweek(sthhind,i-wkstart,hh))

           else if(i .gt. wksample+1) then

              if(hhdatatemp(1,i-1,hh) .gt. 0) then
                 hhdatatemp(1,i,hh) = hhdatatemp(1,i-1,hh)
                 hhdatatemp(3,i,hh) = hhdatatemp(3,i-1,hh)
              endif

           endif

        endif

     enddo

  enddo

  ! fill in the analog of hhweek(nhhvars,).  Note we have a different dimensionality for the simulated data since the set of simulated prices we draw will be different.

  do hh=1,hlen

     do i=wksample+1,wkstart+maxpurchases

        if(hhdatatemp(1,i,hh) .gt. 0) then

           if(.not. inlist(int(hhdatatemp(1,i,hh)),wkstart+maxpurchases-wksample,int(hhdatatemp(2,(wksample+1):(wkstart+maxpurchases),hh))) ) then

              k=1
              do while(hhdatatemp(2,k,hh) .gt. 0)
                 k=k+1
              enddo

              hhdatatemp(2,k,hh) = hhdatatemp(1,i,hh)

           endif

        endif

     enddo

  enddo

  ! element 4 will point to the household's value function we are interpolating

  do hh=1,hlen

     k=0

     do i=wksample+1,wkstart+maxpurchases

        if(hhdatatemp(2,i,hh) .gt. 0) then
           k=k+1

           do j=wksample+1,wkstart+maxpurchases
             if(hhdatatemp(2,i,hh) .eq. hhdatatemp(1,j,hh)) hhdatatemp(4,j,hh) = k
           enddo

        endif

     enddo

  enddo

  do hh=1,hlen

     do i=1,wkstart

        if(initweek(2,i,hh) .gt. dble(bigj)) initweek(2,i,hh) = dble(bigj)

     enddo

  enddo

end subroutine createhhdata


