subroutine setvars

  !This subroutine initializes global variables
  !for use in processing my data and
  !doing the logit estimation

  use params
  implicit none

  integer i,j,maxalf,maxsize

  !choice sets:

  maxsize = 0

  allocate(csetsize(niv),csetnels(niv))

  open(unit=1,file=pathname//prodname//'/csetdims.txt')

  do i=1,niv
     read(1,*) csetsize(i)
     if(csetsize(i) .gt. maxsize) then
        maxsize = csetsize(i)
     endif
  enddo

  do i=1,niv
     read(1,*) csetnels(i)
  enddo

  close(unit=1,status='keep')

  allocate(choicesetmat(3,maxsize,niv),alphabig(3,maxsize,niv))

  open(unit=1,file=pathname//prodname//'/choicesetout.txt')

  do i=1,niv
     do j=1,csetsize(i)
        read(1,*) choicesetmat(:,j,i)
     enddo
  enddo

  close(unit=1,status='keep')

  open(unit=1,file=pathname//prodname//'/alphabigout.txt')

  do i=1,niv
     do j=1,csetsize(i)
        read(1,*) alphabig(:,j,i)
     enddo
  enddo

  close(unit=1,status='keep')

  ! figure out the set of admissable choice sets

  allocate(cadmissable(bigj+1,niv))

  cadmissable(:,1) = .true.

  do i=2,niv
     cadmissable(1,i) = .false.
     do j=1,bigj
        if(i .eq. 2) then
           cadmissable(1+j,i) = mod(j,2) .eq. 0
        else if (i .eq. 3) then
           cadmissable(1+j,i) = mod(j,3) .eq. 0
        else if (i .eq. 4) then
           cadmissable(1+j,i) = mod(j,4) .eq. 0
        else if (i .eq. 5) then
           cadmissable(1+j,i) = mod(j,3) .eq. 0
        endif
     enddo
  enddo

  ! read in alfasmall

  allocate(lalpha(3))

  open(unit=1,file=pathname//prodname//'/lalpha.txt')

  maxalf=0
  if(niv .eq. 5) then
     do i=1,3
        read(1,*) lalpha(i)
        if(lalpha(i) .gt. maxalf) maxalf = lalpha(i)
     enddo
  else
     do i=1,2
        read(1,*) lalpha(i)
        if(lalpha(i) .gt. maxalf) maxalf = lalpha(i)
     enddo
  endif

  close(unit=1,status='keep')

  allocate(alfasmall(3,maxalf,3))

  open(unit=1,file=pathname//prodname//'/alphasmallout.txt')

  if(niv .eq. 5) then
     do i=1,3
        do j=1,lalpha(i)
           read(1,*) alfasmall(i,j,:)
        enddo
     enddo
  else
     do i=1,2
        do j=1,lalpha(i)
           read(1,*) alfasmall(i,j,:)
        enddo
     enddo
  endif

  close(unit=1,status='keep')

  ! set markets for stores - read this from R

  open(unit=1,file=pathname//prodname//'/stmarket.txt')
  do i=1,50
     read(1,*) stmarket(i)
  enddo
  close(unit=1,status='keep')

end subroutine setvars
