# load in parameter estimates, make time plots, and put them into tables
# this will do for both the tuna and soup categories

rm(list=ls())

nstart = 5000
nend   = 25000
nskip  = 1
nvar.tuna = 12
nvar.soup = 18
numprods.t = 6
numprods.s = 12

bigj.tuna = 10
bigj.soup = 20

sgn.tuna = c(rep(1,6),-1,100/bigj.tuna,rep(1,2),-1)
sgn.soup = c(rep(1,12),-1,100/bigj.soup,rep(1,2),-1)

invdiv = 1

estpath.tuna = "C:/Users/MattOsborne/Dropbox/price index paper/estimation data/tuna/"
estpath.soup = "C:/Users/MattOsborne/Dropbox/price index paper/estimation data/sssoup/"
step1path = "C:/Users/MattOsborne/Dropbox/price index paper/step 1 output files/"
tablepath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"
figurepath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"

load(paste(estpath.tuna,"tuna_hhids.RData",sep=""))
allid.tuna = allid
nhhs.tuna = length(allid.tuna)

load(paste(estpath.soup,"soup_hhids.RData",sep=""))
allid.soup = allid
nhhs.soup = length(allid.soup)

# load main coefficient draws

to.read = file(paste(estpath.tuna,"hb/alldraws_a.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
asaves.tuna = t(x3[2:nvar.tuna,])


to.read = file(paste(estpath.tuna,"hb/alldraws_d.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
dsaves.tuna = t(x3[2:nvar.tuna,])

to.read = file(paste(estpath.tuna,"hb/alldraws_bmeans.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
bmeansaves.tuna = t(x3[2:nvar.tuna,])

to.read = file(paste(estpath.tuna,"hb/alldraws_bvar.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
bvarsaves.tuna = sqrt(t(x3[2:nvar.tuna,]))


bmeanall.tuna = apply(t( t(bmeansaves.tuna[seq(nstart,nend,nskip),])*sgn.tuna ),2,mean)
bmeanci.tuna = apply(t( t(bmeansaves.tuna[seq(nstart,nend,nskip),])*sgn.tuna ),2,quantile,probs=c(0.025,0.975))

bvarall.tuna = apply(t( t(bvarsaves.tuna[seq(nstart,nend,nskip),])*abs(sgn.tuna) ),2,mean)
bvarci.tuna = apply(t( t(bvarsaves.tuna[seq(nstart,nend,nskip),])*abs(sgn.tuna) ),2,quantile,probs=c(0.025,0.975))

to.read = file(paste(estpath.tuna,"hb/alldraws_types.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x," ")
x3 = matrix(0,nrow=nhhs.tuna,ncol=nend)
for(i in 1:nend) {
  x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
  x3[,i] = x1[[i]]
  if(length(x1[[i]]) != nhhs.tuna | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
}
typesaves.tuna = t(x3)

meantype.tuna = apply(typesaves.tuna[seq(nstart,nend,nskip),],2,mean)

# identify stockpilers and non-stockpilers
# a 0.5 cutoff seems to do a good job of separation

stockpiler.tuna = meantype.tuna > 0.5

hbdraws.tuna = read.table(paste(estpath.tuna,"hb/hbmeans.dat",sep=""))

drawmeans.tuna = vector("list",length=2)

drawmeans.tuna[[1]] = apply(hbdraws.tuna[!stockpiler.tuna,],2,mean)
drawmeans.tuna[[2]] = apply(hbdraws.tuna[stockpiler.tuna,],2,mean)


to.read = file(paste(estpath.soup,"hb/alldraws_a.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.soup,ncol=length(x))
asaves.soup = t(x3[2:nvar.soup,])


to.read = file(paste(estpath.soup,"hb/alldraws_d.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.soup,ncol=length(x))
dsaves.soup = t(x3[2:nvar.soup,])

to.read = file(paste(estpath.soup,"hb/alldraws_bmeans.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.soup,ncol=length(x))
bmeansaves.soup = t(x3[2:nvar.soup,])

to.read = file(paste(estpath.soup,"hb/alldraws_bvar.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.soup,ncol=length(x))
bvarsaves.soup = sqrt(t(x3[2:nvar.soup,]))


bmeanall.soup = apply(t( t(bmeansaves.soup[seq(nstart,nend,nskip),])*sgn.soup ),2,mean)
bmeanci.soup = apply(t( t(bmeansaves.soup[seq(nstart,nend,nskip),])*sgn.soup ),2,quantile,probs=c(0.025,0.975))

bvarall.soup = apply(t( t(bvarsaves.soup[seq(nstart,nend,nskip),])*abs(sgn.soup)),2,mean)
bvarci.soup = apply(t( t(bvarsaves.soup[seq(nstart,nend,nskip),])*abs(sgn.soup)),2,quantile,probs=c(0.025,0.975))


to.read = file(paste(estpath.soup,"hb/alldraws_types.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x," ")
x3 = matrix(0,nrow=nhhs.soup,ncol=nend)
for(i in 1:nend) {
  x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
  x3[,i] = x1[[i]]
  if(length(x1[[i]]) != nhhs.soup | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
}
typesaves.soup = t(x3)

meantype.soup = apply(typesaves.soup[seq(nstart,nend,nskip),],2,mean)

# identify stockpilers and non-stockpilers
# a 0.5 cutoff seems to do a good job of separation

stockpiler.soup = meantype.soup > 0.5

hbdraws.soup = read.table(paste(estpath.soup,"hb/hbmeans.dat",sep=""))

drawmeans.soup = vector("list",length=2)

drawmeans.soup[[1]] = apply(hbdraws.soup[!stockpiler.soup,],2,mean)
drawmeans.soup[[2]] = apply(hbdraws.soup[stockpiler.soup,],2,mean)

# load log likelihoods

ll = read.table(paste(estpath.tuna,"hb/alldraws_ll.dat",sep=""),stringsAsFactors=FALSE)
ll.t = as.double(ll$V1)

ll = read.table(paste(estpath.soup,"hb/alldraws_ll.dat",sep=""),stringsAsFactors=FALSE)
ll.s = as.double(ll$V1)

# load type probabilities

p = read.table(paste(estpath.tuna,"hb/alldraws_p.dat",sep=""))
p.t = as.double(p$V1[seq(2,2*nend,2)])

p = read.table(paste(estpath.soup,"hb/alldraws_p.dat",sep=""))
p.s = as.double(p$V1[seq(2,2*nend,2)])


sdraws = seq(nstart,nend,nskip)

p.t.mean = mean(p.t[sdraws])
p.t.centiles = quantile(p.t[sdraws],probs=c(0.025,0.975))

p.s.mean = mean(p.s[sdraws])
p.s.centiles = quantile(p.s[sdraws],probs=c(0.025,0.975))

np.t = 11

expc.t = rep(TRUE,np.t)
expc.t[1:(numprods.t-1)] = FALSE
expc.t[(np.t-2):np.t] = FALSE

negc.t = rep(FALSE,np.t)
negc.t[11] = TRUE

fixed.t = rep(FALSE,np.t)
fixed.t[c(3:5,7,9:11)] = TRUE


np.s = 17

expc.s = rep(TRUE,np.s)
expc.s[1:(numprods.s-1)] = FALSE
expc.s[(np.s-2):np.s] = FALSE

negc.s = rep(FALSE,np.s)
negc.s[17] = TRUE

fixed.s = rep(FALSE,np.s)
fixed.s[c(1,6:10,13,15:17)] = TRUE


tform.coef <- function(a,d,expc,negc,fixed,sdraws,probs = c(0.025,0.975)) {

  np = length(expc)

  tr.a = matrix(0,nrow=nrow(a),ncol=ncol(a))

  ameans = rep(0,np)
  astd = rep(0,np)
  acentiles = matrix(0,nrow=2,ncol=np)

  dmeans = rep(0,np)
  dstd = rep(0,np)
  dcentiles = matrix(0,nrow=2,ncol=np)

  for(i in 1:np) {

    if(!fixed[i]) {

      if(expc[i]) {
        z2 = exp(a[sdraws,i] + 0.5*d[sdraws,i])
      } else {
        z2 = a[sdraws,i]
      }

      ameans[i] = mean(z2)
      astd[i] = sd(z2)

      if(negc[i]) {
        acentiles[1:2,i] = quantile(-z2,probs=probs)
      } else {
        acentiles[1:2,i] = quantile(z2,probs=probs)
      }

      if(expc[i]) {
        tr.a[,i] = exp(a[,i] + 0.5*d[,i])

        z2 = (exp(d[sdraws,i])-1)*exp(2*a[sdraws,i] + d[sdraws,i])
      } else {
        tr.a[,i] = a[,i]

        z2 = d[sdraws,i]
      }

      dmeans[i] = mean(sqrt(z2))
      dstd[i] = sd(sqrt(z2))

      dcentiles[1:2,i] = quantile(sqrt(z2),probs=probs)

    } else {

      if(expc[i]) {

        ameans[i] = mean(exp(a[sdraws,i]))
        astd[i] = sd(exp(a[sdraws,i]))
        tr.a[,i] = exp(a[,i])

        if(negc[i]) {
          acentiles[1:2,i] = quantile(-exp(a[sdraws,i]),probs=probs)
        } else {
          acentiles[1:2,i] = quantile(exp(a[sdraws,i]),probs=probs)
        }

      } else {

        ameans[i] = mean(a[sdraws,i])
        astd[i] = sd(a[sdraws,i])
        tr.a[,i] = a[,i]

        acentiles[1:2,i] = quantile(a[sdraws,i],probs=probs)

      }

    }

    if(negc[i]) {
      tr.a[,i] = -tr.a[,i]
      ameans[i] = -ameans[i]
    }

  }

  return(list(tr.a=tr.a,ameans=ameans,astd=astd,acentiles=acentiles,dmeans=dmeans,dstd=dstd,dcentiles=dcentiles))

}

res.t = tform.coef(asaves.tuna,dsaves.tuna,expc.t,negc.t,fixed.t,sdraws)
res.s = tform.coef(asaves.soup,dsaves.soup,expc.s,negc.s,fixed.s,sdraws)

# make time plots of all the model coefficients, and the marginal likelihood

pnames.other = c("Consumption","Storage Cost","Price","Feature","Display","Fixed Cost of Purchase")

bnames.tuna = c("COS Water","SK Water","SK Oil","Private Label Water","3 Diamonds Water")

bnames.soup = c("Campbells Tomato","Campbells Chkn Noodle","Campbells Cream of Chkn","Campbells Cream of Celery",
"Campbells Bean and Bacon","Campbells Vegetable Beef","Private Label Cream of Mush","Private Label Tomato",
"Campells Vegetable","Campbells Composite","Private Label Composite")

png(paste(figurepath,"brandests_tuna.png",sep=""),width=640,height=640)
par(mfrow=c(2,2))
for(i in 1:4) {
  plot(res.t$tr.a[,i],type="l",xlab="Draw",ylab="",main=bnames.tuna[i])
}
dev.off()

png(paste(figurepath,"otherests_tuna.png",sep=""),width=640,height=640)
par(mfrow=c(3,2))
for(i in (np.t-5):np.t) {
  if(i-(np.t-6) == 3) {
    xx = 100/bigj.tuna
  } else {
    xx = 1
  }
  plot(xx*res.t$tr.a[,i],type="l",xlab="Draw",ylab="",main=pnames.other[i-(np.t-6)])
}
dev.off()

png(paste(figurepath,"brandests_soup.png",sep=""),width=640,height=640)
par(mfrow=c(2,2))
for(i in 1:4) {
  plot(res.s$tr.a[,i],type="l",xlab="Draw",ylab="",main=bnames.soup[i])
}
dev.off()

png(paste(figurepath,"otherests_soup.png",sep=""),width=640,height=640)
par(mfrow=c(3,2))
for(i in (np.s-5):np.s) {
  if(i-(np.s-6) == 3) {
    xx = 100/bigj.soup
  } else {
    xx = 1
  }
  plot(xx*res.s$tr.a[,i],type="l",xlab="Draw",ylab="",main=pnames.other[i-(np.s-6)])
}
dev.off()

png(paste(figurepath,"ll_plots.png",sep=""),width=640,height=640)
par(mfrow=c(1,2))
plot(ll.t,type="l",xlab="Draw",ylab="",main="Canned Tuna")
plot(ll.s,type="l",xlab="Draw",ylab="",main="Canned Soup")
dev.off()


# tables

cond <- function(x,a,b) {

  if(x) {
    return(a)
  } else {
    return(b)
  }

}

esttab.t = rep("",np.t)

esttab.t[1:(numprods.t-1)] = paste(bnames.tuna,"($\\gamma$)")
esttab.t[numprods.t:np.t] = paste(pnames.other,c("($\\beta$)","","($\\alpha_i$)","","",""))

for(i in 1:np.t) {

  sigfig = rep(3,4)

  esttab.t[i] = paste(esttab.t[i]," & ",round(bmeanall.tuna[i],sigfig[1])," & (",round(bmeanci.tuna[1,i],sigfig[2]),", ",round(bmeanci.tuna[2,i],sigfig[2]),") & ",cond(bvarall.tuna[i]==0," - ",round(bvarall.tuna[i],sigfig[3]))," & ",cond(bvarall.tuna[i] == 0," - ",paste("(",round(bvarci.tuna[1,i],sigfig[4]),", ",round(bvarci.tuna[2,i],sigfig[4]),")",sep="")),"\\\\",sep="")
}

esttab.t[np.t+1] = "\\hline"
esttab.t[np.t+2] = paste("Prob of Low Cost Type & ",round(p.t.mean,sigfig[1])," & (",round(p.t.centiles[1],sigfig[2]),", ",round(p.t.centiles[2],sigfig[2]),") & - & - \\\\",sep="")

esttab.s = rep("",np.s)

esttab.s[1:(numprods.s-1)] = paste(bnames.soup,"($\\gamma$)")
esttab.s[numprods.s:np.s] = paste(pnames.other,c("($\\beta$)","","($\\alpha_i$)","","",""))

for(i in 1:np.s) {

  sigfig = rep(3,4)

  esttab.s[i] = paste(esttab.s[i]," & ",round(bmeanall.soup[i],sigfig[1])," & (",round(bmeanci.soup[1,i],sigfig[2]),", ",round(bmeanci.soup[2,i],sigfig[2]),") & ",cond(bvarall.soup[i]==0," - ",round(bvarall.soup[i],sigfig[3]))," & ",cond(bvarall.soup[i] == 0," - ",paste("(",round(bvarci.soup[1,i],sigfig[4]),", ",round(bvarci.soup[2,i],sigfig[4]),")",sep="")),"\\\\",sep="")
}

esttab.s[np.s+1] = "\\hline"
esttab.s[np.s+2] = paste("Prob of Low Cost Type & ",round(p.s.mean,sigfig[1])," & (",round(p.s.centiles[1],sigfig[2]),", ",round(p.s.centiles[2],sigfig[2]),") & - & - \\\\",sep="")

write.table(esttab.t,file=paste(tablepath,"mainest_tuna.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

write.table(esttab.s,file=paste(tablepath,"mainest_soup.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

# extra tables: parameters broken out by type, projected on demographics

load(paste(step1path,"demographics.RData",sep=""))

# put people into income quartiles
# I've based this on the tuna data
# income (0-3,4-5,6-7,8+)
# size: (1-2,3+)

demo.tuna1 = demo.tuna[demo.tuna$hhid %in% allid.tuna,]
demo.tuna1 = demo.tuna1[order(demo.tuna1$hhid),]
demo.tuna1$stockpiler = stockpiler.tuna

demo.tuna1$inc2 = demo.tuna1$hhincome %in% c(4,5)
demo.tuna1$inc3 = demo.tuna1$hhincome %in% c(6,7)
demo.tuna1$inc4 = demo.tuna1$hhincome > 7

demo.tuna1$size2 = demo.tuna1$hhsize > 2

res.dtuna = lm(stockpiler~inc2+inc3+inc4+size2+factor(restype),data=demo.tuna1)

demo.soup1 = demo.soup[demo.soup$hhid %in% allid.soup,]
demo.soup1 = demo.soup1[order(demo.soup1$hhid),]
demo.soup1$stockpiler = stockpiler.soup

demo.soup1$inc2 = demo.soup1$hhincome %in% c(4,5)
demo.soup1$inc3 = demo.soup1$hhincome %in% c(6,7)
demo.soup1$inc4 = demo.soup1$hhincome > 7

demo.soup1$size2 = demo.soup1$hhsize > 2

res.dsoup = lm(stockpiler~inc2+inc3+inc4+size2+factor(restype),data=demo.soup1)

print(summary(res.dtuna))
print(summary(res.dsoup))

se.tuna = sqrt(diag(summary(res.dtuna)$cov.unscaled))*summary(res.dtuna)$sigma
se.soup = sqrt(diag(summary(res.dsoup)$cov.unscaled))*summary(res.dsoup)$sigma


sigfig = 3

reg.table = c("Intercept","Income (20-50\\%)","Income (50-75\\%)",
"Income (75-100\\%)","Size $>$ 2","Condo","Single Family","Multiple Family",
"Mobile Home","Other")


sstar <- function(m,s) {

  if(abs(m)/s > 1.96) {
    return("**")
  } else if (abs(m)/s > 1.65) {
    return("*")
  } else {
    return("")
  }

}

for(i in 1:length(reg.table)) {
  reg.table[i] = paste(reg.table[i]," & ",round(res.dtuna$coefficients[i],sigfig),
           sstar(res.dtuna$coefficients[i],se.tuna[i]),
           " (",round(se.tuna[i],sigfig)," ) & ",round(res.dsoup$coefficients[i],sigfig),
           sstar(res.dsoup$coefficients[i],se.soup[i]),
           " (",round(se.soup[i],sigfig)," ) \\\\",sep="")
}

reg.table[length(reg.table)+1] = paste("$R^2$ & ",
         round(summary(res.dtuna)$r.squared,sigfig),
         " & ",round(summary(res.dsoup)$r.squared,sigfig)," \\\\",sep="")

write.table(reg.table,file=paste(tablepath,"demographic_regressions.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")


# consumption and price coefficients for each type

cinds.tuna = c(6,8)
cinds.soup = c(12,14)

coef.type.table = c("Consumption","Price")

for(i in 1:2) {
  coef.type.table[i] = paste(coef.type.table[i]," & ",
                 round(drawmeans.tuna[[2]][cinds.tuna[i]]*sgn.tuna[cinds.tuna[i]],sigfig)," & ",
                 round(drawmeans.tuna[[1]][cinds.tuna[i]]*sgn.tuna[cinds.tuna[i]],sigfig)," & ",
                 round(drawmeans.soup[[2]][cinds.soup[i]]*sgn.soup[cinds.soup[i]],sigfig)," & ",
                 round(drawmeans.soup[[1]][cinds.soup[i]]*sgn.soup[cinds.soup[i]],sigfig)," \\\\",sep="")
}

write.table(coef.type.table,file=paste(tablepath,"coefs_by_demos.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

stop()

# robustness check 1: bigger Nu and Nm

# load main coefficient draws

to.read = file(paste(robustpath1,"alldraws_a.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
asaves.robust1 = t(x3[2:nvar.tuna,])


to.read = file(paste(robustpath1,"alldraws_d.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
dsaves.robust1 = t(x3[2:nvar.tuna,])

to.read = file(paste(robustpath1,"alldraws_bmeans.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
bmeansaves.robust1 = t(x3[2:nvar.tuna,])

to.read = file(paste(robustpath1,"alldraws_bvar.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.tuna,ncol=length(x))
bvarsaves.robust1 = sqrt(t(x3[2:nvar.tuna,]))


bmeanall.robust1 = apply(t( t(bmeansaves.robust1[seq(nstart,nend,nskip),])*sgn.tuna ),2,mean)
bmeanci.robust1 = apply(t( t(bmeansaves.robust1[seq(nstart,nend,nskip),])*sgn.tuna ),2,quantile,probs=c(0.025,0.975))

bvarall.robust1 = apply(t( t(bvarsaves.robust1[seq(nstart,nend,nskip),])*abs(sgn.tuna) ),2,mean)
bvarci.robust1 = apply(t( t(bvarsaves.robust1[seq(nstart,nend,nskip),])*abs(sgn.tuna) ),2,quantile,probs=c(0.025,0.975))

to.read = file(paste(robustpath1,"alldraws_types.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x," ")
x3 = matrix(0,nrow=559,ncol=nend)
for(i in 1:nend) {
  x1[[i]] = as.double(x1[[i]][x1[[i]] != ""])
  x3[,i] = x1[[i]]
  if(length(x1[[i]]) != 559 | sum(is.na(x1[[i]])) > 0 | typeof(x1[[i]]) != "double" ) {print(paste("check draw",i))}
}
typesaves.robust1 = t(x3)

meantype.robust1 = apply(typesaves.robust1[seq(nstart,nend,nskip),],2,mean)


esttab.r1 = rep("",np.t)

esttab.r1[1:(numprods.t-1)] = paste(bnames.tuna,"($\\gamma$)")
esttab.r1[numprods.t:np.t] = paste(pnames.other,c("($\\beta$)","","($\\alpha_i$)","","",""))

# load log likelihoods

ll = read.table(paste(robustpath1,"alldraws_ll.dat",sep=""),stringsAsFactors=FALSE)
ll.r1 = as.double(ll$V1)

# load type probabilities

p = read.table(paste(robustpath1,"alldraws_p.dat",sep=""))
p.r1 = as.double(p$V1[seq(2,2*nend,2)])

p.r1.mean = mean(p.r1[sdraws])
p.r1.centiles = quantile(p.r1[sdraws],probs=c(0.025,0.975))

for(i in 1:np.t) {

  sigfig = rep(3,4)

  esttab.r1[i] = paste(esttab.r1[i]," & ",round(bmeanall.robust1[i],sigfig[1])," & (",round(bmeanci.robust1[1,i],sigfig[2]),", ",round(bmeanci.robust1[2,i],sigfig[2]),") & ",cond(bvarall.robust1[i]==0," - ",round(bvarall.robust1[i],sigfig[3]))," & ",cond(bvarall.robust1[i] == 0," - ",paste("(",round(bvarci.robust1[1,i],sigfig[4]),", ",round(bvarci.robust1[2,i],sigfig[4]),")",sep="")),"\\\\",sep="")
}

esttab.r1[np.t+1] = "\\hline"
esttab.r1[np.t+2] = paste("Prob of Low Cost Type & ",round(p.r1.mean,sigfig[1])," & (",round(p.r1.centiles[1],sigfig[2]),", ",round(p.r1.centiles[2],sigfig[2]),") & - & - \\\\",sep="")

write.table(esttab.r1,file=paste(tablepath,"robust1_tuna.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")

# robustness check 2: no fixed cost of purchase

np.r2 = np.t - 1

expc.r2 = rep(TRUE,np.r2)
expc.r2[1:(numprods.t-1)] = FALSE
expc.r2[(np.r2-2):np.r2] = FALSE

negc.r2 = rep(FALSE,np.r2)
#negc.t[11] = TRUE

fixed.r2 = rep(FALSE,np.r2)
fixed.r2[c(3:5,7,9:10)] = TRUE


# load main coefficient draws

nvar.r2 = nvar.tuna - 1

to.read = file(paste(robustpath2,"alldraws_a.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.r2,ncol=length(x))
asaves.robust2 = t(x3[2:nvar.r2,])


to.read = file(paste(robustpath2,"alldraws_d.dat",sep=""),"rt")
x=readLines(to.read)
close(to.read)

x = x[1:length(x)%%2==0]
x1 = strsplit(x,"       ")
x2 = as.double(unlist(x1))
x3 = matrix(x2,nrow=nvar.r2,ncol=length(x))
dsaves.robust2 = t(x3[2:nvar.r2,])

res.r2 = tform.coef(asaves.robust2,dsaves.robust2,expc.r2,negc.r2,fixed.r2,sdraws)


esttab.r2 = rep("",np.r2)

esttab.r2[1:(numprods.t-1)] = paste(bnames.tuna,"($\\gamma$)")
esttab.r2[numprods.t:np.r2] = paste(pnames.other[-length(pnames.other)],c("($\\beta$)","","($\\alpha_i$)","",""))

# load log likelihoods

ll = read.table(paste(robustpath2,"alldraws_ll.dat",sep=""),stringsAsFactors=FALSE)
ll.r2 = as.double(ll$V1)

# load type probabilities

p = read.table(paste(robustpath2,"alldraws_p.dat",sep=""))
p.r2 = as.double(p$V1[seq(2,2*nend,2)])

p.r2.mean = mean(p.r2[sdraws])
p.r2.centiles = quantile(p.r2[sdraws],probs=c(0.025,0.975))

for(i in 1:np.r2) {

  sigfig = rep(3,4)

  esttab.r2[i] = paste(esttab.r2[i]," & ",round(res.r2$ameans[i],sigfig[1])," & (",round(res.r2$acentiles[1,i],sigfig[2]),", ",round(res.r2$acentiles[2,i],sigfig[2]),") & ",cond(res.r2$dmeans[i]==0," - ",round(res.r2$dmeans[i],sigfig[3]))," & ",cond(res.r2$dstd[i] == 0," - ",paste("(",round(res.r2$dcentiles[1,i],sigfig[4]),", ",round(res.r2$dcentiles[2,i],sigfig[4]),")",sep="")),"\\\\",sep="")

}

esttab.r2[np.r2+1] = "\\hline"
esttab.r2[np.r2+2] = paste("Prob of Low Cost Type & ",round(p.r2.mean,sigfig[1])," & (",round(p.r2.centiles[1],sigfig[2]),", ",round(p.r2.centiles[2],sigfig[2]),") & - & - \\\\",sep="")

write.table(esttab.r2,file=paste(tablepath,"robust2_tuna.tex",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE,sep="")
