# this file loads in the ERIM scanner data, and saves it into R files for
# further processing

rm(list=ls())

product = "tuna"
inputpath = "C:/Users/MattOsborne/Dropbox/price index paper/input data/"            # put raw data here
outputpath = "C:/Users/MattOsborne/Dropbox/price index paper/step 1 output files/"  # intermediate output files go here

hhpurch = read.fwf(file=paste(inputpath,product,"/",product,"_f1.dat",sep=""),width=c(2,2,6,1,1,8,13,4,1,5,7,7,3,3,5,3,5,11,4,rep(1,10),3),stringsAsFactors=FALSE)

colnames(hhpurch) = c("cellident","market","week","day","tripnum","hhid","upc","storeid","storetype","units","price","weight","couponcode",
                      "storecouponunits","storecouponvalue","mancouponunits","mancouponvalue","eqfactor","rsln",
                      "eadc","fadc","iadc","odc","adcode","adtype","inadcc","popcode","spcode","cf","filler")

stdata = read.fwf(file=paste(inputpath,product,"/",product,"_f5.dat",sep=""),width=c(2,4,13,6,rep(1,8),7,2,2),stringsAsFactors=FALSE)
colnames(stdata) = c("market","storeid","upc","week","eadc","fadc","iadc","odc","adcode","inadcc","popcode","spcode",
                     "price","pmultiple","filler")

branddata = read.fwf(file=paste(inputpath,product,"/",product,"_f6.dat",sep=""),width=c(13,30,2,6,7,3,11,4),stringsAsFactors=FALSE)
colnames(branddata) = c("upc","desc","wtcode","wtdesc","wtamt","multipack","eqfactor","rsln")

save(hhpurch,stdata,branddata,file=paste(outputpath,"erim_",product,".RData",sep=""))

hhvisit = read.fwf(file=paste(inputpath,product,"/",product,"_f2.dat",sep=""),width=c(2,4,1,8,6,7),stringsAsFactors=FALSE)
colnames(hhvisit) = c("market","storeid","storetype","hhid","week","dollars")
save(hhvisit,file=paste(outputpath,"visits_",product,".RData",sep=""))
