rm(list=ls())

library(plm)

product = "tuna"

inputpath = "C:/Users/MattOsborne/Dropbox/price index paper/step 1 output files/"                   #data from step 1
outputpath = "C:/Users/MattOsborne/Dropbox/price index paper/estimation data/"         #output data for fortran code
tablepath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"    #tables for paper
figpath = "C:/Users/MattOsborne/Dropbox/price index paper/output tables and figures/"      #figures for paper


load(paste(inputpath,"erim_",product,".RData",sep=""))
load(paste(inputpath,"weeklyprices_",product,".RData",sep=""))
load(paste(inputpath,"bdatabig_",product,".RData",sep=""))

stdata = stdata[-c(1234:1539,1819:2049),]

load(file=paste(inputpath,"visits_",product,".RData",sep=""))

hhpurch$filler <- NULL

hhpurch = merge(hhpurch,bdatabig,all.x=TRUE)

stdata = merge(stdata,bdatabig,all.x=TRUE)
stdata = stdata[order(stdata$storeid,stdata$week,stdata$brandid,stdata$oilwtr,stdata$upc),]

stmarket = rep(0,50)
for(i in 1:50) {
  if(sum(stdata$storeid==i) > 0) {
    stmarket[i] = max(stdata$market[stdata$storeid==i])
  }
}
write.table(as.integer(stmarket),file=paste(outputpath,product,"/stmarket.txt",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)

allweek = unique(hhpurch$week)
allweek = allweek[order(allweek)]

allstids = unique(stdata$storeid[stdata$market == 1])
allstids = allstids[order(allstids)]

# aggregate data to the week-store level
hhvisit = hhvisit[hhvisit$market == 1,]
temp = aggregate(hhvisit$dollars,by=list(hhvisit$hhid,hhvisit$week,hhvisit$storeid),FUN=sum)
colnames(temp) = c("hhid","week","storeid","dollars")
hhvisit = temp

# merge purchases with visits
hhpurch = hhpurch[hhpurch$market == 1,]
hhpurch$filler = NULL

# compute measures of brand loyalty
# define loyal as greater than 0.8 of all purchases

brlist = c(4,8,11,12)

hhp1 = hhpurch[,c("hhid","week","storeid","brandid")]
for(i in 1:length(brlist)) {
  hhp1[[paste("brand",i,sep="")]] = hhp1$brandid == brlist[i]
  temp = aggregate(hhp1[[paste("brand",i,sep="")]],by=list(hhp1$hhid),FUN=mean)
  colnames(temp) = c("hhid",paste("fr",i,sep=""))
  if(i==1) {
    purchfr = temp
  } else {
    purchfr[[paste("fr",i,sep="")]] = temp[[paste("fr",i,sep="")]]
  }
  cat("Fraction of households loyal to product ",i,": ",mean(purchfr[[paste("fr",i,sep="")]]>0.8),"\n")
}

hhall = merge(hhpurch,hhvisit,all.y=TRUE)

# merge in prices and advertising

# first construct average prices from the price files, and advertising from the store files

brpurch = aggregate(hhpurch$units,by = list(hhpurch$week,hhpurch$brandid,hhpurch$oilwtr),FUN=sum)
colnames(brpurch) = c("week","brandid","oilwtr","x")

brands = unique(bdatabig$brandid)
brands = brands[order(brands)]

qwts = array(0,c(length(allweek),length(brands),2))

for(br in brands) {
  for(i in 1:2) {
    wks = which(allweek %in% brpurch$week[brpurch$brandid==br & brpurch$oilwtr==i])
    qwts[wks,br,i] = brpurch$x[brpurch$brandid==br & brpurch$oilwtr == i]
  }
}

avgprices = data.frame(kronecker(allstids,rep(1,length(allweek))),rep(allweek,length(allstids)))
colnames(avgprices) = c("storeid","week")
avgprices$price <- 0
avgprices$units <- 0
avgprices$sale <- 0
avgprices$feat <- 0
avgprices$disp <- 0
avgprices$otherad <- 0

j=0
for(br in brands) {
  j=j+1
  for(ow in 1:2) {
    for(st in allstids) {
      pfinds = pf1w$SID == st & pf1w$brandid == br & pf1w$oilwtr == ow
      wks = pf1w$erimweek[pfinds]
      if(length(wks) > 0) {
        inds = avgprices$storeid == st & avgprices$week %in% wks
        avgprices$price[inds] = avgprices$price[inds] + qwts[allweek %in% wks,j,ow]*pf1w$price[pfinds]
        avgprices$units[inds] = avgprices$units[inds] + qwts[allweek %in% wks,j,ow]
        avgprices$sale[inds] = pmax(avgprices$sale[inds], pf1w$sale[pfinds])

        hhinds = hhpurch$brandid == br & hhpurch$oilwtr == ow & hhpurch$storeid == st
        if(sum(hhinds) > 0) {
          disp1 = hhpurch$eadc[hhinds] == "Y" | hhpurch$iadc[hhinds] == "Y" | hhpurch$fadc[hhinds] == "Y" | hhpurch$odc[hhinds] == "Y"
          disp2 = aggregate(disp1,by=list(hhpurch$week[hhinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% disp2[,1]
          avgprices$disp[inds2] = pmax(avgprices$disp[inds2],disp2$x)
          feat1 = hhpurch$adtype[hhinds] == "L" | hhpurch$adtype[hhinds] == "M"
          feat2 = aggregate(feat1,by=list(hhpurch$week[hhinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% feat2[,1]
          avgprices$feat[inds2] = pmax(avgprices$feat[inds2],feat2$x)
          other1 = hhpurch$inadcc[hhinds] == "Y" | hhpurch$popcode[hhinds] == "Y"
          other2 = aggregate(other1,by=list(hhpurch$week[hhinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% other2[,1]
          avgprices$otherad[inds2] = pmax(avgprices$otherad[inds2],other2$x)
        }
        stinds = stdata$brandid == br & stdata$oilwtr == ow & stdata$storeid == st
        if(sum(stinds) > 0) {
          disp1 = stdata$eadc[stinds] == "Y" | stdata$iadc[stinds] == "Y" | stdata$fadc[stinds] == "Y" | stdata$odc[stinds] == "Y"
          disp2 = aggregate(disp1,by=list(stdata$week[stinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% disp2[,1]
          avgprices$disp[inds2] = pmax(avgprices$disp[inds2],disp2$x)
          feat1 = stdata$adcode[stinds] == "L" | stdata$adcode[stinds] == "M"
          feat2 = aggregate(feat1,by=list(stdata$week[stinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% feat2[,1]
          avgprices$feat[inds2] = pmax(avgprices$feat[inds2],feat2$x)
          other1 = stdata$inadcc[stinds] == "Y" | stdata$popcode[stinds] == "Y"
          other2 = aggregate(other1,by=list(stdata$week[stinds]),FUN=max)
          inds2 = avgprices$storeid == st & avgprices$week %in% other2[,1]
          avgprices$otherad[inds2] = pmax(avgprices$otherad[inds2],other2$x)
        }

      }
    }
  }
}

avgprices$price[avgprices$units > 0] = avgprices$price[avgprices$units > 0]/avgprices$units[avgprices$units > 0]
avgprices$units = NULL

hhall$pprice = hhall$price
hhall$price = NULL

hhall = merge(hhall,avgprices,all.x=TRUE)

hhall$units[is.na(hhall$units)] = 0
hhall$wtamt[is.na(hhall$wtamt)] = 0

# compute household consumption rates, and then inventories

# first collapse data to the week level
hhall1 = hhall[hhall$price > 0,]
dollars1 = aggregate(hhall1$dollars,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(dollars1) = c("hhid","week","maxdollars")
hhall1 = merge(hhall1,dollars1)
rm(dollars1)

totunits = aggregate((hhall1$units/100)*(hhall1$wtamt/1000),by=list(hhall1$hhid,hhall1$week),FUN=sum)   #Important: UNITS MUST BE MULTIPLIED BY WEIGHT
colnames(totunits) = c("hhid","week","totunits")
hhall1 = merge(hhall1,totunits)

hhall1 = hhall1[(hhall1$totunits > 0 & hhall1$units > 0) | (hhall1$totunits == 0 & hhall1$dollars == hhall1$maxdollars),]

price1 = aggregate(hhall1$price,by=list(hhall1$hhid,hhall1$week),FUN=mean)
colnames(price1) = c("hhid","week","price")

feat1 = aggregate(hhall1$feat,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(feat1) = c("hhid","week","feat")

disp1 = aggregate(hhall1$disp,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(disp1) = c("hhid","week","disp")

other1 = aggregate(hhall1$otherad,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(other1) = c("hhid","week","otherad")

sale1 = aggregate(hhall1$sale,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(sale1) = c("hhid","week","sale")

water1 = aggregate(hhall1$oilwtr==2,by=list(hhall1$hhid,hhall1$week),FUN=max)
colnames(water1) = c("hhid","week","water")

brdum = vector("list",length=length(brands))
hhall1$brandid[is.na(hhall1$brandid)] = 0

for(br in brands) {
  brdum[[br]] = aggregate(hhall1$brandid==br,by=list(hhall1$hhid,hhall1$week),FUN=max)
  colnames(brdum[[br]]) = c("hhid","week","x")
}

stdum = vector("list",length=length(allstids))

j=0
for(st in allstids) {
  j=j+1
  stdum[[j]] = aggregate(hhall1$storeid==st,by=list(hhall1$hhid,hhall1$week),FUN=max)
  colnames(stdum[[j]]) = c("hhid","week","x")
}

hhallw = price1
hhallw$feat = feat1$feat
hhallw$disp = disp1$disp
hhallw$otherad = other1$otherad
hhallw$sale = sale1$sale
hhallw$water = water1$water
hhallw$units = totunits$totunits

for(br in brands) {
  hhallw[[paste("br",br,sep="")]] = brdum[[br]]$x
}

j=0
for(st in allstids) {
  j=j+1
  hhallw[[paste("st",st,sep="")]] = stdum[[j]]$x
}

hhallw$units1 = hhallw$units*6.5/100
hhallw$ppoz = hhallw$price/6.5

fmla1 = paste("units~ppoz+sale+sale*ppoz+feat+disp+water+",paste(paste("br",brands[c(-1,-5,-7,-10,-14,-15)],sep=""),collapse="+"),"+",
    paste(paste("st",allstids[c(-1,-which(allstids %in% c(32,33,34,35)))],sep=""),collapse="+"),sep="")
print(summary(lm(as.formula(fmla1),data=hhallw)))

# compute household level consumption rates

wkindex = rep(0,nrow(hhallw))

for(i in 1:length(allweek)) {
  wkindex[hhallw$week == allweek[i]] = i
}


minweek = aggregate(wkindex,by=list(hhallw$hhid),FUN=min)
maxweek = aggregate(wkindex,by=list(hhallw$hhid),FUN=max)
hhunits = aggregate(hhallw$units,by=list(hhallw$hhid),FUN=sum)

hhcrate = hhunits$x/(maxweek$x-minweek$x+1)
hhallw = hhallw[order(hhallw$hhid,hhallw$week),]

dyn.load("functions.dll")

inv = .Call("computeinv",hhallw,hhcrate)

dyn.unload("functions.dll")

hhallw$inv = inv
hhallw$inv1 = hhallw$inv*6.5/100

fmla2 = paste(fmla1,"inv",sep="+")

res = plm(as.formula(fmla2),data=hhallw,index=c("hhid","week"))

print(summary(res))

coeftuna = summary(res)$coefficients

save(coeftuna,file=paste(outputpath,product,"/coef",product,".RData",sep=""))

# compute indexes plus imputed inventories

# first find stores that have complete price series

stweeks = array(0,c(length(allstids),length(brands),2))

startweek = 73
k=0
for(st in allstids) {
  k=k+1
  i=0
  for(br in brands) {
    i=i+1
    for(j in 1:2) {
      stweeks[k,i,j] = sum(pf1w$erimweek >= allweek[startweek] & pf1w$SID == st & pf1w$brandid == br & pf1w$oilwtr == j)
    }
  }
}

stcomplete = rep(TRUE, length(allstids))
tdelta = 0

binclude = c(8,11)

k=0
for(st in allstids) {
  k=k+1
  i=0
  for(br in binclude) {
    i=which(br==brands)
    for(j in 1:2) {
      stcomplete[k] = stcomplete[k] & stweeks[k,i,j] >= length(allweek)-startweek+1-tdelta
    }
  }
}

# check for evidence of nonlinear pricing

load(paste(inputpath,"dailyprices1_",product,".RData",sep=""))
pf1 = pf1[pf1$UPC %in% unique(pf1w$UPC),]

load(paste(inputpath,"d2w.RData",sep=""))

pf1$erimweek = 0
for(i in 1:nrow(d2w)) {
  pf1$erimweek[pf1$DATE >= d2w$mindate[i] & pf1$DATE <= d2w$maxdate[i]] = d2w$erimweek[i]
}

pf1$dayofweek = weekdays(pf1$DATE)
pf1$erimday = 1
j=1
for(i in c("Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")) {
  j=j+1
  pf1$erimday[pf1$dayofweek == i] = j
}

pcheck = pf1
pcheck = pcheck[,c("erimweek","erimday","UPC","SID","DPR","REG")]
colnames(pcheck) = c("week","day","upc","storeid","stprice","REG")

pmerge = merge(hhpurch,pcheck)
pmerge$ppunit = pmerge$price/pmerge$units
pmerge$ppunit[is.na(pmerge$ppunit)] = pmerge$stprice[is.na(pmerge$ppunit)]  #only one observation

ii = pmerge$units > 100

sum( abs(pmerge$ppunit[ii] - pmerge$stprice[ii]) > 0.01 )/nrow(pmerge[ii,])  # this matches up well

badobs = abs(pmerge$ppunit - pmerge$stprice) > 0.01 & ii

upccheck = unique(pf1$UPC)

hhpurch1 = aggregate(hhpurch$price,by=list(hhpurch$upc,hhpurch$storeid,hhpurch$week,hhpurch$day,hhpurch$units),FUN=mean)

colnames(hhpurch1) = c("upc","storeid","week","day","units","avgprice")

hhpurch1 = hhpurch1[hhpurch1$upc %in% upccheck,]

punit = vector("list",length=6)

for(i in 1:6) {

  punit[[i]] = hhpurch1[hhpurch1$units==i*100,]
  colnames(punit[[i]]) = c("upc","storeid","week","day","units",paste("p",i,sep=""))
  punit[[i]]$units <- NULL

}

for(i in 1:6) {

  hhpurch1 = merge(hhpurch1,punit[[i]],all.x=TRUE)
  hhpurch1[[paste("p",i,sep="")]][is.na(hhpurch1[[paste("p",i,sep="")]])] = 0

}

mmat = matrix(0,nrow=6,ncol=6)
difmat = matrix(0,nrow=6,ncol=6)
pdifmat = array(0,c(6,6,2))
remainders = matrix(0,nrow=6,ncol=2)

for(i in 1:6) {
  remainders[i,1] = sum(hhpurch1[[paste("p",i,sep="")]]%%i > 0)
  remainders[i,2] = sum(hhpurch1[[paste("p",i,sep="")]] > 0)
  for(j in 1:6) {
    ii = (hhpurch1[[paste("p",i,sep="")]] > 0) & (hhpurch1[[paste("p",j,sep="")]] > 0)
    mmat[i,j] = sum( ii )
    difmat[i,j] = sum( hhpurch1[[paste("p",i,sep="")]][ii]/i != hhpurch1[[paste("p",j,sep="")]][ii]/j )
    ii2 = hhpurch1[[paste("p",i,sep="")]]/i != hhpurch1[[paste("p",j,sep="")]]/j & ii
    pdifmat[i,j,1] = mean(hhpurch1[[paste("p",i,sep="")]][ii2]/i)
    pdifmat[i,j,2] = mean(hhpurch1[[paste("p",j,sep="")]][ii2]/j)
  }
}

# look at pmultiple

print(table(stdata$pmultiple[stdata$market==1]))
print(sum(stdata$pmultiple[stdata$market==1] > 1)/sum(stdata$market==1))

print(remainders)
print(sum(remainders[2:6,1])/sum(remainders[2:6,]))
print(pdifmat)

pdiftab = rep(paste(1:4," Unit(s)",sep=""))

for(i in 1:4) {
  for(j in 1:6) {
    if(difmat[i,j] == 0 | i > j) {
      pdiftab[i] = paste(pdiftab[i]," & - ",sep="")
    } else {
      pdiftab[i] = paste(pdiftab[i]," & ",round(100*difmat[i,j]/mmat[i,j],1)," (",round(abs(pdifmat[i,j,1]-pdifmat[i,j,2]),1),") ",sep="")
    }
  }
  pdiftab[i] = paste(pdiftab[i]," \\\\",sep="")
}

write.table(pdiftab,file=paste(tablepath,"ditftab_tuna.txt",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)  # this is in the paper

# we need to add initial periods into hhall1 so we can construct initweekdata

minweek = allweek[73]

qcutoff = 5

maxu = 10

upckeep = c(17800000120,17800000240,79100002450,79100002800,75450022620,77600152580)

commoncols = colnames(hhall1)[colnames(hhall1) %in% colnames(hhpurch)]
missingcols = colnames(hhall1)[!(colnames(hhall1) %in% colnames(hhpurch))]

hhpurch1 = hhpurch[hhpurch$week < minweek,]
hhpurch1 = hhpurch1[hhpurch1$weight == 6500,]
tunits1 = aggregate(hhpurch1$units,by=list(hhpurch1$hhid,hhpurch1$week),FUN=sum)
colnames(tunits1) = c("hhid","week","tunits")

# collapsing the data - it doesn't matter how we do this, since we're not dealing
# with brand specific inventory.  The store might differ if there are
# 2 different store purchases in a week, but this is rare

hhpurch1$obsnum = 1:nrow(hhpurch1)
maxobs = aggregate(hhpurch1$obsnum,by=list(hhpurch1$hhid,hhpurch1$week),FUN=max)
colnames(maxobs) = c("hhid","week","maxobs")

hhpurch1 = merge(hhpurch1,maxobs,all.x=TRUE)

hhpurch1 = merge(hhpurch1,tunits1,all.x=TRUE)

hhpurch1 = hhpurch1[hhpurch1$obsnum == hhpurch1$maxobs,]
hhpurch1$obsnum <- NULL
hhpurch1$maxobs <- NULL

hhpurch1$units = hhpurch1$tunits
hhpurch1$tunits <- NULL

hhpurch1 = hhpurch1[,commoncols]
for(i in missingcols) {
  hhpurch1[[i]] = 0
}


hhall2 = rbind(hhpurch1[hhpurch1$week < minweek,],hhall1[,c(commoncols,missingcols)])


hhall2$upc[is.na(hhall2$upc)] = 0

badobs1 = !( (hhall2$upc %in% upckeep & hhall2$week >= minweek) | hhall2$upc == 0 | (hhall2$weight == 6500 & hhall2$week < minweek) )

hhall2$totb = 0

for(i in 1:length(upckeep)) {
  hhall2[[paste("b",i,sep="")]] = hhall2$upc == upckeep[i]
  bweek = aggregate(hhall2[[paste("b",i,sep="")]],by=list(hhall2$hhid,hhall2$week),FUN=max)
  colnames(bweek) = c("hhid","week",paste("mb",i,sep=""))
  hhall2 = merge(hhall2,bweek,all.x=TRUE)
  hhall2$totb = hhall2$totb + hhall2[[paste("mb",i,sep="")]]
}

badobs2 = hhall2$totb > 1

badobs = badobs1 | badobs2

badhh1 = aggregate(badobs1[hhall2$week >= minweek],by=list(hhall2$hhid[hhall2$week >= minweek]),FUN=max)

badhh2 = aggregate(badobs2[hhall2$week >= minweek],by=list(hhall2$hhid[hhall2$week >= minweek]),FUN=max)

badhh = aggregate(badobs[hhall2$week >= minweek],by=list(hhall2$hhid[hhall2$week >= minweek]),FUN=max)

colnames(badhh) = c("hhid","badhh")

hhall2 = merge(hhall2,badhh,all.x=TRUE)

npurchweek = aggregate( hhall2$totb[hhall2$week >= minweek], by=list(hhall2$hhid[hhall2$week >= minweek],hhall2$week[hhall2$week >= minweek]), FUN=max )

colnames(npurchweek) = c("hhid","week","npweek")

hhall2 = merge(hhall2,npurchweek,all.x=TRUE)

npurchhh = aggregate( hhall2$npweek[hhall2$week >= minweek] > 0,  by=list(hhall2$hhid[hhall2$week >= minweek]), FUN=sum)

colnames(npurchhh) = c("hhid","nphh")

hhall2 = merge(hhall2,npurchhh,all.x=TRUE)

# now start creating a final sample

finalhh = hhall2$badhh == 0 & hhall2$nphh >= qcutoff

hhall3 = hhall2[finalhh,]

# we still want to limit to hhs where purch occasions are from 1 store in 1 week and less than 10 units, and you make 25 or more store visits

nunitswk = aggregate(hhall3$units/100,by=list(hhall3$hhid,hhall3$week), FUN=sum)
colnames(nunitswk) = c("hhid","week","unitswk")

hhall3 = merge(hhall3,nunitswk,all.x=TRUE)

nmaxu = aggregate(hhall3$unitswk[hhall3$week >= minweek] > maxu, by = list(hhall3$hhid[hhall3$week >= minweek]), FUN = max)
colnames(nmaxu) = c("hhid","nmaxu")

hhall3 = merge(hhall3,nmaxu,all.x=TRUE)

hhall3 = hhall3[hhall3$nmaxu == 0,]

nobs2 = aggregate(hhall3$hhid,by=list(hhall3$hhid,hhall3$week),FUN=length)

colnames(nobs2) = c("hhid","week","nobswk")

nobs3 = aggregate(nobs2$nobswk,by=list(nobs2$hhid),FUN=max)

colnames(nobs3) = c("hhid","maxobs")

hhall3 = merge(hhall3,nobs3,all.x=TRUE)

hhall3 = hhall3[hhall3$maxobs == 1,]

nobs4 = aggregate(hhall3$hhid[hhall3$week >= minweek],by=list(hhall3$hhid[hhall3$week >= minweek]),FUN=length)
colnames(nobs4) = c("hhid","hhobs")

hhall3 = merge(hhall3,nobs4)
hhall3 = hhall3[hhall3$hhobs >= 25,]

# now merge in prices, feature, display, etc

# when purchases are observed we have daily data.  When not we have weekly data.  First, we will take the price
# file's advertising variables and make them weekly.

pf1w = pf1w[order(pf1w$UPC,pf1w$SID,pf1w$erimweek),]

MAJOR = aggregate(pf1$MAJOR,by = list(pf1$UPC,pf1$SID,pf1$erimweek), FUN=max)
colnames(MAJOR) = c("UPC","SID","erimweek","MAJOR")
MAJOR = MAJOR[MAJOR$erimweek > 0 & MAJOR$erimweek < 198724,]

pf1w$MAJOR = MAJOR$MAJOR

LINE = aggregate(pf1$LINE,by = list(pf1$UPC,pf1$SID,pf1$erimweek), FUN=max)
colnames(LINE) = c("UPC","SID","erimweek","LINE")
LINE = LINE[LINE$erimweek > 0 & LINE$erimweek < 198724,]

pf1w$LINE = LINE$LINE

DISPLAY = aggregate(pf1$DISPLAY,by = list(pf1$UPC,pf1$SID,pf1$erimweek), FUN=max)
colnames(DISPLAY) = c("UPC","SID","erimweek","DISPLAY")
DISPLAY = DISPLAY[DISPLAY$erimweek > 0 & DISPLAY$erimweek < 198724,]

pf1w$DISPLAY = DISPLAY$DISPLAY


hhall3.1 = hhall3[hhall3$units > 0,]

for(i in 1:length(upckeep)) {
  pf1temp = pf1[pf1$UPC == upckeep[i],c("erimweek","erimday","SID","DPR","MAJOR","LINE","DISPLAY")]
  colnames(pf1temp) = c("week","day","storeid",paste("price",i,sep=""),paste("major",i,sep=""),paste("line",i,sep=""),paste("display",i,sep=""))
  hhall3.1 = merge(hhall3.1,pf1temp,all.x=TRUE)
}

hhall3.2 = hhall3[hhall3$units == 0,]

for(i in 1:length(upckeep)) {
  pf1temp = pf1w[pf1w$UPC == upckeep[i],c("erimweek","SID","price","MAJOR","LINE","DISPLAY")]
  colnames(pf1temp) = c("week","storeid",paste("price",i,sep=""),paste("major",i,sep=""),paste("line",i,sep=""),paste("display",i,sep=""))
  hhall3.2 = merge(hhall3.2,pf1temp,all.x=TRUE)
}

hhall3.3 = rbind(hhall3.1,hhall3.2)

hhall3.3 = hhall3.3[order(hhall3.3$hhid,hhall3.3$week),]

# create fortran input data

nvar = 8+3*length(upckeep)
nhhs = length(unique(hhall3.3$hhid))
nweek = 51
initweek = 72

prweights = rbind(c(0.1,0.32)/0.42,c(0.09,0.37)/0.46)   # these are the price averaging weights I used in the fortran code
# UPCs are 5: 79100002800, 6: 79100002450
# 10: 17800000240, 11: 17800000120

hhall4 = data.frame(kronecker(unique(hhall3.3$hhid),rep(1,nweek+initweek)),rep(allweek,nhhs))
colnames(hhall4) = c("hhid","week")
hhall4 = merge(hhall4,hhall3.3,all.x=TRUE)
hhall4$upc[is.na(hhall4$upc)] = 0
hhall4$units[is.na(hhall4$units)] = 0
hhall4$storeid[is.na(hhall4$storeid)] = 0  # in the fortran code no store visit is coded as zero
for(i in 1:length(upckeep)) {
  hhall4[[paste("price",i,sep="")]][is.na(hhall4[[paste("price",i,sep="")]])] = 0
  hhall4[[paste("major",i,sep="")]][is.na(hhall4[[paste("major",i,sep="")]])] = 0
  hhall4[[paste("line",i,sep="")]][is.na(hhall4[[paste("line",i,sep="")]])] = 0
  hhall4[[paste("display",i,sep="")]][is.na(hhall4[[paste("display",i,sep="")]])] = 0
}

hhall4 = hhall4[order(hhall4$hhid,hhall4$week),]

hhweek = array(0,c(nvar,initweek+nweek,nhhs))

# average prices for store visits where all prices are missing

mkt1stids = unique(hhall4$storeid[hhall4$storeid > 0])

avgprices = array(0,c(50,length(upckeep)))
badstids = NULL
for(i in 1:50) {
  if(sum(pf1w$SID == i) == 0 & i %in% mkt1stids) {
    badstids = c(badstids,i)
    # here we have a storeid that is visited sufficiently few times we don't really get a price - so just use average
    for(j in 1:length(upckeep)) {
      inds = hhpurch$upc == upckeep[j] & hhpurch$storeid == i
      if(sum(inds) > 0) {
        avgprices[i,j] = mean(hhpurch$price[inds]*100/hhpurch$units[inds],na.rm=TRUE)
      }
    }
  }
}


for(i in 1:(nweek+initweek)) {
  xx = hhall4$week == allweek[i]
  for(j in 1:length(upckeep)) {
    hhweek[1,i,hhall4$upc[xx] == upckeep[j]] = j
    hhweek[2,i,hhall4$upc[xx] == upckeep[j]] = hhweek[2,i,hhall4$upc[xx] == upckeep[j]] + hhall4$units[xx][hhall4$upc[xx] == upckeep[j]]/100
  }
  hhweek[5,i,] = hhall4$storeid[xx]

  for(j in 1:length(upckeep)) {
    hhweek[5+j,i,] = hhall4[[paste("price",j,sep="")]][xx]*100
      # fill in the missing prices
    for(st in badstids) {
      inds = hhall4$storeid[xx] == st
      if(sum(inds) > 0) {
        hhweek[5+j,i,inds] = avgprices[st,j]
      }
    }
    hhweek[5+length(upckeep)+j,i,] = pmax(hhall4[[paste("major",j,sep="")]][xx],hhall4[[paste("line",j,sep="")]][xx])
    hhweek[5+2*length(upckeep)+j,i,] = hhall4[[paste("display",j,sep="")]][xx]
  }

}

# store visit probability

stvisitprob = aggregate(hhall4$storeid[hhall4$week >= minweek] > 0,by=list(hhall4$hhid[hhall4$week >= minweek]), FUN=mean)

hhweek[nvar-2,,] = matrix(stvisitprob$x,nrow=nweek+initweek,ncol=nhhs,byrow=TRUE)

initweekdata = hhweek[,1:initweek,]
hhweek1 = hhweek[,1:nweek+initweek,]

# write in information on number of households, etc

sasprices = array(0,c(50,123,3*length(upckeep)))
regprices = array(0,c(50,123,length(upckeep)))
deal = array(FALSE,c(50,123,length(upckeep)))

write.table(as.integer(c(nvar,nhhs)),paste(outputpath,product,"/Rinfo_hn.txt",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)
for(i in 1:nhhs) {
  write.table(t(hhweek1[,,i]),paste(outputpath,product,"/Rhhweek_hn.txt",sep=""),append = i > 1,quote=FALSE,row.names=FALSE,col.names=FALSE)
}

for(i in 1:nhhs) {
  write.table(t(initweekdata[,,i]),paste(outputpath,product,"/Rinitweek_hn.txt",sep=""),append = i > 1,quote=FALSE,row.names=FALSE,col.names=FALSE)
}

dummyarray = matrix(0,nrow=length(allweek),ncol=3*length(upckeep))
prarray = data.frame(allweek,stringsAsFactors=FALSE)
colnames(prarray) = "erimweek"

pf1w$feat = pmax(pf1w$MAJOR,pf1w$LINE)
for(i in 1:50) {
  if(sum(pf1w$SID == i) == 0 & i %in% mkt1stids) {
    # here we have a storeid that is visited sufficiently few times we don't really get a price - so just use average
    temp = prarray
    for(j in 1:length(upckeep)) {
      inds = hhpurch$upc == upckeep[j] & hhpurch$storeid == i
      if(sum(inds) > 0) {
        temp[[paste("price",j,sep="")]] = mean(hhpurch$price[inds]*100/hhpurch$units[inds],na.rm=TRUE)
      } else {
        temp[[paste("price",j,sep="")]] = 0
      }
    }
    for(j in 1:(2*length(upckeep))) {
      temp = cbind(temp,rep(0,nrow(temp)))
    }
    tempreg = temp
    tempdeal = temp
    tempdeal[,2:ncol(tempdeal)] = FALSE
    cat("using average prices for store ",i,"\n")
    write.table(temp[,1+1:(3*length(upckeep))],paste(outputpath,product,"/Rstores_hn.txt",sep=""),append = i > 1,quote=FALSE,row.names=FALSE,col.names=FALSE)
    sasprices[i,,] = as.matrix(temp[,1+1:(3*length(upckeep))])
    regprices[i,,] = as.matrix(temp[,1+1:(length(upckeep))])
  } else if(sum(pf1w$SID == i) > 0) {
    temp = prarray
    tempreg = prarray
    tempdeal = prarray
    for(j in 1:length(upckeep)) {
      temp = merge(temp,pf1w[pf1w$UPC == upckeep[j] & pf1w$SID == i,c("erimweek","price")],all.x=TRUE)
      colnames(temp)[j+1] = paste("price",j,sep="")
      temp[[paste("price",j,sep="")]][is.na(temp[[paste("price",j,sep="")]])] = 0
      temp[[paste("price",j,sep="")]] = temp[[paste("price",j,sep="")]]*100

      tempreg = merge(tempreg,pf1w[pf1w$UPC == upckeep[j] & pf1w$SID == i,c("erimweek","REG")],all.x=TRUE)
      colnames(tempreg)[j+1] = paste("REG",j,sep="")
      tempreg[[paste("REG",j,sep="")]][is.na(tempreg[[paste("REG",j,sep="")]])] = 0
      tempreg[[paste("REG",j,sep="")]] = tempreg[[paste("REG",j,sep="")]]*100

      tempdeal = merge(tempdeal,pf1w[pf1w$UPC == upckeep[j] & pf1w$SID == i,c("erimweek","sale")],all.x=TRUE)
      colnames(tempdeal)[j+1] = paste("sale",j,sep="")
      tempdeal[[paste("sale",j,sep="")]][is.na(tempdeal[[paste("sale",j,sep="")]])] = 0
      tempdeal[[paste("sale",j,sep="")]] = tempdeal[[paste("sale",j,sep="")]]*100
    }
    for(j in 1:length(upckeep)) {
      temp = merge(temp,pf1w[pf1w$UPC == upckeep[j] & pf1w$SID == i,c("erimweek","feat")],all.x=TRUE)
      colnames(temp)[j+1+length(upckeep)] = paste("feat",j,sep="")
      temp[[paste("feat",j,sep="")]][is.na(temp[[paste("feat",j,sep="")]])] = 0
    }
    for(j in 1:length(upckeep)) {
      temp = merge(temp,pf1w[pf1w$UPC == upckeep[j] & pf1w$SID == i,c("erimweek","DISPLAY")],all.x=TRUE)
      colnames(temp)[j+1+2*length(upckeep)] = paste("display",j,sep="")
      temp[[paste("display",j,sep="")]][is.na(temp[[paste("display",j,sep="")]])] = 0
    }
    temp = temp[order(temp$erimweek),]
    tempreg = tempreg[order(tempreg$erimweek),]
    tempdeal = tempdeal[order(tempdeal$erimweek),]
    psum = apply(temp[,1+1:length(upckeep)],1,sum)
    if(sum(psum == 0) > 0) {
      cat("imputing prices for store",i,",",sum(psum == 0),"weeks \n")
      #if it is at the beginning or end just impute forwards or backwards
      if(max(diff(which(psum==0))) == 1) {
        if(min(which(psum==0)) == 1) {
          lastprice = temp[min(which(psum>0)),1+1:length(upckeep)]
        } else {
          lastprice = temp[max(which(psum>0)),1+1:length(upckeep)]
        }
        temp[psum==0,1+1:length(upckeep)] = matrix(unlist(lastprice),nrow=sum(psum==0),ncol=length(upckeep),byrow=TRUE)
        tempreg[psum==0,1+1:length(upckeep)] = matrix(unlist(lastprice),nrow=sum(psum==0),ncol=length(upckeep),byrow=TRUE)
      } else {
        # break into pieces
        nbreak = 1+sum(diff(which(psum==0))>1)
        if(nbreak == 2 & min(which(psum==0)) == 1 & max(which(psum==0))==length(psum)) {
          breakpoint = 1+which(diff(which(psum==0))>1)
          lastp1 = temp[min(which(psum>0)),1+1:length(upckeep)]
          lastp2 = temp[max(which(psum>0)),1+1:length(upckeep)]
          temp[1:(breakpoint-1),1+1:length(upckeep)] = matrix(unlist(lastp1),nrow=breakpoint-1,ncol=length(upckeep),byrow=TRUE)
          temp[(breakpoint+max(diff(which(psum==0)))):length(psum),1+1:length(upckeep)] = matrix(unlist(lastp2),nrow=length(psum)-(breakpoint+max(diff(which(psum==0))))+1,ncol=length(upckeep),byrow=TRUE)
          tempreg[1:(breakpoint-1),1+1:length(upckeep)] = matrix(unlist(lastp1),nrow=breakpoint-1,ncol=length(upckeep),byrow=TRUE)
          tempreg[(breakpoint+max(diff(which(psum==0)))):length(psum),1+1:length(upckeep)] = matrix(unlist(lastp2),nrow=length(psum)-(breakpoint+max(diff(which(psum==0))))+1,ncol=length(upckeep),byrow=TRUE)
        } else {
          stop("price break in the middle - need a different procedure\n")
        }
      }
    }
    write.table(temp[,1+1:(3*length(upckeep))],paste(outputpath,product,"/Rstores_hn.txt",sep=""),append = i > 1,quote=FALSE,row.names=FALSE,col.names=FALSE)
    sasprices[i,,] = as.matrix(temp[,1+1:(3*length(upckeep))])
    regprices[i,,] = as.matrix(tempreg[,1+1:(length(upckeep))])
    deal[i,,] = as.matrix(tempdeal[,1+1:(length(upckeep))])
  } else {
    write.table(dummyarray,paste(outputpath,product,"/Rstores_hn.txt",sep=""),append = i > 1,quote=FALSE,row.names=FALSE,col.names=FALSE)
  }
}

# compute importance distribution
# estimate the brand level model and then use average moments of that
# we will normalize the first product to 1

ll.brand <- function(x1,hhbrand,fx) {

  x = rep(0,length(fx))
  x[!fx] = x1

  prices = hhbrand[,1+1:length(upckeep)]
  feat = hhbrand[,1+length(upckeep)+1:length(upckeep)]
  display = hhbrand[,1+2*length(upckeep)+1:length(upckeep)]

  u = matrix(x[1:length(upckeep)],nrow=nrow(prices),ncol=length(upckeep),byrow=TRUE) - x[1+length(upckeep)]*prices +
      x[2+length(upckeep)]*feat + x[3+length(upckeep)]*display

  eu = exp(u)
  eu[prices==0] = 0
  denom = apply(eu,1,sum)

  cprob = eu[cbind(1:nrow(hhbrand),hhbrand[,1])]/denom

  if(x[1+length(upckeep)] < 0) {
    penalty = 1000*(x[1+length(upckeep)])^2
  } else {
    penalty = 0
  }

  return(-sum(log(cprob))+penalty)

}

inds = hhall4$units > 0 & hhall4$week >= minweek
chosenb = rep(0,sum(inds))
for(j in 1:length(upckeep)) {
  chosenb[hhall4$upc[inds] == upckeep[j]] = j
}

hhbrand = chosenb
for(j in 1:length(upckeep)) {
  hhbrand = cbind(hhbrand,hhall4[[paste("price",j,sep="")]][inds])
}

for(j in 1:length(upckeep)) {
  hhbrand = cbind(hhbrand,pmax(hhall4[[paste("major",j,sep="")]][inds],hhall4[[paste("line",j,sep="")]][inds]))
}

for(j in 1:length(upckeep)) {
  hhbrand = cbind(hhbrand,hhall4[[paste("display",j,sep="")]][inds])
}

xstart = c(rep(0,length(upckeep)-1),0.02,0)
fx = c(TRUE,rep(FALSE,length(upckeep)-1),FALSE,FALSE,TRUE)

out = optim(xstart,ll.brand,control=list(maxit=5000),hhbrand=hhbrand,fx=fx)

getiv <- function(x1,hhbrand,fx) {

  x = rep(0,length(fx))
  x[!fx] = x1

  prices = hhbrand[,1+1:length(upckeep)]
  feat = hhbrand[,1+length(upckeep)+1:length(upckeep)]
  display = hhbrand[,1+2*length(upckeep)+1:length(upckeep)]

  u = matrix(x[1:length(upckeep)],nrow=nrow(prices),ncol=length(upckeep),byrow=TRUE) - x[1+length(upckeep)]*prices +
      x[2+length(upckeep)]*feat + x[3+length(upckeep)]*display

  eu = exp(u)
  eu[prices==0] = 0
  denom = log(apply(eu,1,sum))

  return(denom)

}

iv = getiv(out$par,hhbrand,fx)

ivstats = c(mean(iv),sd(iv))

# do mcmc to get parameter heterogeneity

hhbrand2 = data.frame(cbind(hhall4$hhid[inds],hhall4$week[inds],hhbrand))
colnames(hhbrand2) = c("hhid","week","chosenb",paste("price",1:length(upckeep),sep=""),
        paste("feat",1:length(upckeep),sep=""),paste("display",1:length(upckeep),sep=""))

hhbrand2 = hhbrand2[order(hhbrand2$hhid,hhbrand2$week),]

hhids = unique(hhbrand2$hhid)
hhids = hhids[order(hhids)]

save(hhall4,hhbrand,hhbrand2,hhpurch,hhallw,sasprices,deal,regprices,hhweek,initweek,fmla1,fmla2,file=paste(outputpath,product,"/tuna_finaldata.RData",sep=""))

source("mcmc_tuna.r")

write.table(ivstats,paste(outputpath,product,"/ivstats.txt",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)

write.table(ivmeanhh$x,paste(outputpath,product,"/ivstatshh.txt",sep=""),quote=FALSE,row.names=FALSE,col.names=FALSE)

write.table(ivsdhh$x,paste(outputpath,product,"/ivstatshh.txt",sep=""),append=TRUE,quote=FALSE,row.names=FALSE,col.names=FALSE)



