nupcs = length(upckeep)
ndraws = 10000
nfaccept = 50
nprint = 100

rho = c(sqrt(0.05),0.1)

bdraws = array(0,c(nhhs,length(out$par),ndraws))

xx = rep(0,length(fx))
xx[!fx] = out$par

b0 = matrix(xx,nrow=length(hhids),ncol=length(fx),byrow=TRUE)

zerovar = rep(FALSE,length(fx))
zerovar[2] = TRUE
zerovar[fx] = TRUE

b = out$par[!zerovar[!fx]]
b1 = b0
W = diag(sum(!zerovar))
S0 = W
v0 = 10

pastfaccept = rep(FALSE,nfaccept)

set.seed(82531952)

ll.brand.hh <- function(x,hhweek1,csout,nupcs,alphas,nchoices=3,niv=5) {

  ll = .Call("llbrand",t(x),hhweek1,csout,nupcs,alphas,FALSE,TRUE,nchoices,niv)

  return(ll)

}

dyn.load("soup.dll")

for(n in 1:ndraws) {

  # fixed draws

  b1 = b0
  b1[,zerovar & !fx] = b0[,zerovar & !fx]+sqrt(rho[1])*matrix(rnorm(sum(zerovar[!fx])),nrow=nhhs,ncol=sum(zerovar[!fx]),byrow=TRUE)
  if(niv == 5) {
    ll0 = sum(ll.brand.hh(b0,hhweek1,csout,nupcs,alphas))
    ll1 = sum(ll.brand.hh(b1,hhweek1,csout,nupcs,alphas))
  } else {
    ll0 = sum(ll.brand.hh(b0,hhweek1,csout,nupcs,alphas,nchoices=2,niv=niv))
    ll1 = sum(ll.brand.hh(b1,hhweek1,csout,nupcs,alphas,nchoices=2,niv=niv))
  }
  r = exp(ll1-ll0)
  if(runif(1) < r) {
    pastfaccept[n%%nfaccept+1] = TRUE
    b0 = b1
  } else {
    pastfaccept[n%%nfaccept+1] = FALSE
  }
  if(n%%nfaccept == 0) {
    if(mean(pastfaccept) > 0.3) {
      rho[1] = rho[1] + rho[1]*0.1
    } else {
      rho[1] = rho[1] - rho[1]*0.1
    }
  }

  eps = matrix(rnorm(nhhs*sum(!zerovar)),nrow=nhhs,ncol=sum(!zerovar))
  b1[,!zerovar] = b0[,!zerovar] + sqrt(rho[2])*eps%*%chol(W)
  Wi = chol2inv(chol(W))
  if(niv == 5) {
    ll0 = ll.brand.hh(b0,hhweek1,csout,nupcs,alphas)
    ll1 = ll.brand.hh(b1,hhweek1,csout,nupcs,alphas)
  } else {
    ll0 = ll.brand.hh(b0,hhweek1,csout,nupcs,alphas,nchoices=2,niv=niv)
    ll1 = ll.brand.hh(b1,hhweek1,csout,nupcs,alphas,nchoices=2,niv=niv)
  }
  bbig = matrix(b,nrow=nhhs,ncol=sum(!zerovar),byrow=TRUE)
  bdiff0 = t(b0[,!zerovar] - bbig)
  bdiff1 = t(b1[,!zerovar] - bbig)
  phi0 = t(colSums(bdiff0*(Wi%*%bdiff0)))
  phi1 = t(colSums(bdiff1*(Wi%*%bdiff1)))
  r = exp(ll1 - ll0 - 0.5*phi1 +0.5*phi0)

  u = runif(nhhs)
  acceptdraw = u < r & b0[,length(upckeep)+1] >= 0
  b0[acceptdraw,!zerovar] = b1[acceptdraw,!zerovar]

  if(mean(acceptdraw) > 0.3) {
    rho[2] = rho[2] + rho[2]*0.1
  } else {
    rho[2] = rho[2] - rho[2]*0.1
  }

  betamean = apply(b0[,!zerovar],2,mean)
  b = betamean + matrix(rnorm(sum(!zerovar)),nrow=1,ncol=sum(!zerovar))%*%chol(W)/sqrt(nhhs)
  bbig = matrix(b,nrow=nhhs,ncol=sum(!zerovar),byrow=TRUE)

  bb = b0[,!zerovar] - bbig
  S = t(bb)%*%bb + v0*S0
  XX = t(chol(solve(S)))%*%matrix(rnorm(sum(!zerovar)*(v0+nhhs)),nrow=sum(!zerovar),ncol=v0+nhhs)
  W = solve(XX%*%t(XX))

  bdraws[,,n] = b0[,!fx]

  if(n%%nprint==0) {
    cat("Information for iteration ",n,"\n")
    bb = rep(0,length(fx))
    bb[zerovar] = b0[1,zerovar]
    bb[!zerovar] = b

    wdiag = rep(0,length(fx))
    wdiag[!zerovar] = diag(W)
    maxcov = max(W-diag(diag(W)))
    mincov = min(W-diag(diag(W)))

    ests = cbind(bb,wdiag)
    colnames(ests) = c("mean","var")
    print(ests)

    cat("min, max covariances:",c(mincov,maxcov),"\n")

    cat("rho",rho,"\n")
    cat("pct draws acceptance",mean(acceptdraw),mean(pastfaccept),"\n")
  }

}

dyn.unload("soup.dll")

nweeks = length(allweek)-initweek

getiv.hh <- function(bdraws,hhweek1,csout,nupcs,alphas,burnin,fx,skip=10,nprint=1000,nchoices=3,niv=5) {

  ndraws = dim(bdraws)[3]

  for(i in seq(burnin,ndraws,skip)) {

    b = matrix(0,nrow=nhhs,ncol=length(fx))
    b[,!fx] = bdraws[,,i]

    iv = .Call("llbrand",t(b),hhweek1,csout,nupcs,alphas,TRUE,TRUE,nchoices,niv)[[1]]

    if(i == burnin) {
      ivout = data.frame(cbind(kronecker(hhids,rep(1,nweeks)),rep(1:nweeks,nhhs),rep(i-burnin+1,nhhs*nweeks)))
      colnames(ivout) = c("hhid","week","rep")
      for(j in 1:niv) {
        ivout[[paste("iv",j,sep="")]] = as.vector(iv[,,j])
      }
    } else {
      iv1 = data.frame(cbind(kronecker(hhids,rep(1,nweeks)),rep(1:nweeks,nhhs),rep(i-burnin+1,nhhs*nweeks)))
      colnames(iv1) = c("hhid","week","rep")
      for(j in 1:niv) {
        iv1[[paste("iv",j,sep="")]] = as.vector(iv[,,j])
      }
      ivout = rbind(ivout,iv1)
    }

    if(i%%nprint==0) {
      cat("Finished computing for draw",i,"\n")
    }

  }

  return(ivout)

}

save(bdraws,file=paste(outputpath,product,"/bdrawsave_soup.RData",sep=""))

dyn.load("soup.dll")
ivout = getiv.hh(bdraws,hhweek1,csout,nupcs,alphas,2000,fx,nchoices=2,niv=niv)
dyn.unload("soup.dll")

ivout = ivout[ivout$iv1 != 0,]

ivmeanhh = aggregate(ivout[,paste("iv",1:niv,sep="")],by=list(ivout$hhid),FUN=mean)
ivsdhh = aggregate(ivout[,paste("iv",1:niv,sep="")],by=list(ivout$hhid),FUN=sd)

